<template>
  <div class="conainer-fluid">
    <div class="main-martor main-martor-content" data-field-name="content">
      <transition name="slide" mode="out-in" appear>
      <div v-if="showForm" class="section-martor">
        <nav class="tab-martor-menu" style="position:relative">
          <div class="rounded-top bg-white d-flex justify-content-start align-items-center py-2 px-2" id="nav-tab">
            <div class="pr-2">
              <a v-if="markdown.editing" @click="render ()" class="btn btn-primary btn-sm text-nowrap">
                <span class="fw-normal">Preview</span>
              </a>
              <a v-else @click="continueEdit ()" class="btn btn-secondary btn-sm">
                <span class="fw-normal">Continue Editing</span>
              </a>
            </div>

            <div v-if="markdown.editing" class="border-start btn-toolbar martor-toolbar bg-white" role="toolbar" aria-label="Martor Toolbar Buttons">
              <div class="d-flex flex-wrap justify-content-start">
                <div class="btn-group btn-group-sm" role="group" aria-label="First group">
                  <span @click="makeBold ()" class="btn bg-white markdown-selector markdown-bold" title="Bold">
                    <i class="bi bi-type-bold"></i>
                  </span>

                  <span @click="makeItalic ()" class="btn bg-white markdown-selector markdown-italic" title="Italic">
                    <i class="bi bi-type-italic"></i>
                  </span>

                  <span @click="makeStrike ()" class="btn bg-white markdown-selector markdown-italic" title="Stroke">
                    <i class="bi bi-type-strikethrough"></i>
                  </span>

                  <div class="btn-group" role="group">
                    <span id="btnGroupVerticalDropHeading" class="btn bg-white btn-sm dropdown-toggle" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" title="Heading">
                      <i class="bi bi-type-h1"></i>
                    </span>
                    <div class="dropdown-menu" aria-labelledby="btnGroupVerticalDropHeading">
                      <span @click="makeHeading (1)" role="button" class="dropdown-item markdown-selector markdown-h1" title="">Heading 1</span>
                      <span @click="makeHeading (2)" role="button" class="dropdown-item markdown-selector markdown-h2" title="">Heading 2</span>
                      <span @click="makeHeading (3)" role="button" class="dropdown-item markdown-selector markdown-h3" title="">Heading 3</span>
                      <span @click="makeHeading (4)" role="button" class="dropdown-item markdown-selector markdown-h4" title="">Heading 4</span>
                      <span @click="makeHeading (5)" role="button" class="dropdown-item markdown-selector markdown-h5" title="">Heading 5</span>
                      <span @click="makeHeading (6)" role="button" class="dropdown-item markdown-selector markdown-h6" title="">Heading 6</span>
                    </div>
                  </div>
                </div>

                <div class="btn-group btn-group-sm" role="group" aria-label="First group">
                  <span @click="makeUnorderedList ()" class="btn bg-white markdown-selector markdown-unordered-list" title="Unordered List">
                    <i class="bi bi-list-ul"></i>
                  </span>

                  <span @click="makeOrderedList ()" class="btn bg-white markdown-selector markdown-ordered-list" title="Ordered List">
                    <i class="bi bi-list-ol"></i>
                  </span>

                  <span @click="makeTodoList ()" class="d-none btn bg-white markdown-selector markdown-todo-list" title="TODO List">
                    <i class="bi bi-list-check"></i>
                  </span>

                </div>



                <div class="btn-group btn-group-sm" role="group" aria-label="First group">
                  <span @click="makeTable ()" class="btn bg-white markdown-selector markdown-table" title="Table">
                    <i class="bi bi-table"></i>
                  </span>

                  <span @click="makeHLine ()" class="btn bg-white markdown-selector markdown-horizontal" title="Horizontal Line">
                    <i class="bi bi-dash-lg"></i>
                  </span>

                  <span @click="makeBlockquote ()" class="btn bg-white markdown-selector markdown-blockquote" title="Quote">
                    <i class="bi bi-chat-left-quote"></i>
                  </span>

                  <span @click="makeCode ()" class="btn bg-white markdown-selector markdown-ode" title="Code">
                    <i class="bi bi-code-slash"></i>
                  </span>
                </div>



                <div class="btn-group btn-group-sm" role="group" aria-label="First group">
                  <span @click="makeLink ()" class="btn bg-white markdown-selector markdown-link" title="URL/Link">
                    <i class="bi bi-link"></i>
                  </span>

                  <span @click="makeImageLink ()" class="btn bg-white markdown-selector markdown-image-link" title="Insert Image Link">
                    <i class="bi bi-card-image"></i>
                  </span>

                  <span @click="markdown.render_emojis=true" class="btn bg-white markdown-selector markdown-emoji" title="Insert Emoji" data-bs-toggle="modal" data-bs-target="#modal-emoji">
                    <i class="bi bi-emoji-smile"></i>
                  </span>

                  <span class="d-none btn bg-white markdown-selector markdown-image-upload" title="Upload an Image">
                    <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-cloud-upload" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                      <path fill-rule="evenodd" d="M4.406 1.342A5.53 5.53 0 0 1 8 0c2.69 0 4.923 2 5.166 4.579C14.758 4.804 16 6.137 16 7.773 16 9.569 14.502 11 12.687 11H10a.5.5 0 0 1 0-1h2.688C13.979 10 15 8.988 15 7.773c0-1.216-1.02-2.228-2.313-2.228h-.5v-.5C12.188 2.825 10.328 1 8 1a4.53 4.53 0 0 0-2.941 1.1c-.757.652-1.153 1.438-1.153 2.055v.448l-.445.049C2.064 4.805 1 5.952 1 7.318 1 8.785 2.23 10 3.781 10H6a.5.5 0 0 1 0 1H3.781C1.708 11 0 9.366 0 7.318c0-1.763 1.266-3.223 2.942-3.593.143-.863.698-1.723 1.464-2.383z"/>
                      <path fill-rule="evenodd" d="M7.646 4.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 5.707V14.5a.5.5 0 0 1-1 0V5.707L5.354 7.854a.5.5 0 1 1-.708-.708l3-3z"/>
                    </svg>
                    <input name="markdown-image-upload" class="button" type="file" accept="image/*" title="Upload an Image">
                  </span>
                </div>
              </div>

            </div><!-- martor-toolbar -->


            <div class="d-none align-self-start btn-group btn-group-sm ml-auto" role="group" aria-label="First group">
              <span class="btn bg-white markdown-selector markdown-toggle-maximize" title="Full Screen">
                <i v-if="true" class="bi bi-arrows-angle-expand"></i>
                <i v-else class="bi bi-arrows-angle-contract"></i>
              </span>
            </div>

          </div>
        </nav>

        <div class="mt-0" id="nav-tabContent">
          <div class="rounded rounded-bottom bg-white" id="nav-editor-content" aria-labelledby="nav-editor-tab-content">

            <transition name="fade" mode="out-in" appear>

              <textarea @keyup="textModified ()" v-if="markdown.editing" v-model="markdown.text" :style="{'min-height': EDITOR_INIT_HEIGHT + 'px'}"
                class="form-control bg-light martor w-100 pa-3 rounded-0" name="content" cols="40" rows="5" id="markdown-text">
              </textarea>

              <div v-else class="martor-preview bg-light pa-3" id="nav-preview-content" style="border: 1px solid #888;">
                <p v-if="!!markdown.preview" v-html="markdown.preview"></p>
                <p v-else>Nothing to preview</p>
              </div>

            </transition>

            <div class="mt-1 d-flex justify-content-between">
              <div class="text-grey fs-13px mx-3 mt-2">This editor supports <a href="https://www.markdownguide.org/getting-started/" target="new" rel="nofollow">Markdown</a> format</div>
              <div class="btn bg-white markdown-selector markdown-help" title="Markdown Guide (Help)" data-bs-toggle="modal" data-bs-target="#help-guide">
                <div class="d-flex align-items-center"><i class="bi bi-markdown-fill"></i>
                <span class="fs-12px ml-1">Help</span></div>
              </div>
            </div>


          </div>
        </div>
      </div><!-- end  /.section-martor -->
      </transition>



      <div class="modal fade modal-help-guide" id="help-guide" tabindex="-1" aria-labelledby="modalMarkdownGuideTitle" aria-hidden="true">
        <div class="modal-dialog modal-lg modal-dialog-scrollable">
          <div class="modal-content">
            <div class="modal-header bg-grey-lighten-2">
              <h5 class="modal-title" id="modalMarkdownGuideTitle">
                <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-question-circle" fill="currentColor"
                  xmlns="http://www.w3.org/2000/svg">
                  <path fill-rule="evenodd" d="M8 15A7 7 0 1 0 8 1a7 7 0 0 0 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z" />
                  <path
                    d="M5.255 5.786a.237.237 0 0 0 .241.247h.825c.138 0 .248-.113.266-.25.09-.656.54-1.134 1.342-1.134.686 0 1.314.343 1.314 1.168 0 .635-.374.927-.965 1.371-.673.489-1.206 1.06-1.168 1.987l.003.217a.25.25 0 0 0 .25.246h.811a.25.25 0 0 0 .25-.25v-.105c0-.718.273-.927 1.01-1.486.609-.463 1.244-.977 1.244-2.056 0-1.511-1.276-2.241-2.673-2.241-1.267 0-2.655.59-2.75 2.286zm1.557 5.763c0 .533.425.927 1.01.927.609 0 1.028-.394 1.028-.927 0-.552-.42-.94-1.029-.94-.584 0-1.009.388-1.009.94z" />
                </svg>
                <span class="ms-1">Markdown Guide</span>
              </h5>
              <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
              <table class="table fs-14px markdown-reference">
                <thead>
                  <tr class="table-light">
                    <th colspan="2">Code</th>
                    <th>Shown As</th>
                  </tr>
                </thead>
                <tbody>

                  <tr>
                    <td colspan="2">:emoji_name:</td>
                    <td><img class="marked-emoji" src="/static/plugins/images/heart.png"></td>
                  </tr>

                  <tr>
                    <td colspan="2">*Italic*<br>_Italic_</td>
                    <td><em>Italic</em></td>
                  </tr>
                  <tr>
                    <td colspan="2">**Bold**<br>__Bold__</td>
                    <td><strong>Bold</strong></td>
                  </tr>
                  <tr>
                    <td colspan="2">++Underscores++</td>
                    <td><ins>Underscores</ins></td>
                  </tr>
                  <tr>
                    <td colspan="2">~~Strikethrough~~</td>
                    <td><del>Strikethrough</del></td>
                  </tr>
                  <tr>
                    <td colspan="2"># Heading 1</td>
                    <td>
                      <h2>Heading 1</h2>
                    </td>
                  </tr>
                  <tr>
                    <td colspan="2">## Heading 2</td>
                    <td>
                      <h3>Heading 2</h3>
                    </td>
                  </tr>
                  <tr>
                    <td colspan="2">[Link](http://a.com)</td>
                    <td><a href="http://commonmark.org/" class="text-blue">Link</a></td>
                  </tr>
                  <tr>
                    <td colspan="2">[Link][1]<br> &#8285;<br> [1]: http://b.org</td>
                    <td><a href="http://commonmark.org/" class="text-blue">Link</a></td>
                  </tr>
                  <tr>
                    <td colspan="2">![Image](http://url/a.png)</td>
                    <td><img src="/static/plugins/images/commonmark.png" width="36" height="36" alt="Markdown"></td>
                  </tr>
                  <tr>
                    <td colspan="2">![Image][1]<br> &#8285;<br> [1]: http://url/b.jpg</td>
                    <td><img src="/static/plugins/images/commonmark.png" width="36" height="36" alt="Markdown"></td>
                  </tr>
                  <tr>
                    <td colspan="2">&gt; Blockquote</td>
                    <td>
                      <blockquote>Blockquote</blockquote>
                    </td>
                  </tr>
                  <tr>
                    <td colspan="2">A paragraph.<br><br> A paragraph after 1 blank line.</td>
                    <td>
                      <p>A paragraph.</p>
                      <p>A paragraph after 1 blank line.</p>
                    </td>
                  </tr>
                  <tr>
                    <td width="20%">
                      <p>- List<br> - List<br> - List</p>
                    </td>
                    <td width="35%">
                      <p>* List<br> * List<br> * List</p>
                    </td>
                    <td>
                      <ul style="padding-left: 14px;">
                        <li>List</li>
                        <li>List</li>
                        <li>List</li>
                      </ul>
                    </td>
                  </tr>
                  <tr>
                    <td>
                      <p> 1. One<br> 2. Two<br> 3. Three</p>
                    </td>
                    <td>
                      <p> 1) One<br> 2) Two<br> 3) Three</p>
                    </td>
                    <td>
                      <ol style="padding-left: 14px;">
                        <li>One</li>
                        <li>Two</li>
                        <li>Three</li>
                      </ol>
                    </td>
                  </tr>
                  <tr>
                    <td colspan="2">Horizontal Rule<br>-----------<br>or<br>***********</td>
                    <td>Horizontal Rule
                      <hr>
                    </td>
                  </tr>
                  <tr>
                    <td colspan="2">`Inline code` with backticks</td>
                    <td><code>Inline code</code> with backticks</td>
                  </tr>
                  <tr>
                    <td colspan="2">```<br> def whatever(foo):<br>&nbsp;&nbsp;&nbsp;&nbsp;return foo<br>```</td>
                    <td>
                      <code><pre class="fs-14px">def whatever(foo):<br />  return foo</pre></code>
                    </td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
      </div><!-- modal -->

      <div class="modal fade modal-emoji" id="modal-emoji" tabindex="-1" aria-labelledby="modalInsertEmojiTitle" aria-hidden="true">
        <div class="modal-dialog modal-lg modal-dialog-scrollable">
          <div class="modal-content emoji-content-base">
            <div class="modal-header bg-grey-lighten-2">
              <h5 class="modal-title" id="modalInsertEmojiTitle">
                <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-info-circle" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                  <path fill-rule="evenodd" d="M8 15A7 7 0 1 0 8 1a7 7 0 0 0 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"/>
                  <path d="M8.93 6.588l-2.29.287-.082.38.45.083c.294.07.352.176.288.469l-.738 3.468c-.194.897.105 1.319.808 1.319.545 0 1.178-.252 1.465-.598l.088-.416c-.2.176-.492.246-.686.246-.275 0-.375-.193-.304-.533L8.93 6.588z"/>
                  <circle cx="8" cy="4.5" r="1"/>
                </svg>
                <span class="ms-1">Select Emoji to Insert</span>
              </h5>
              <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body emoji-content-base">
              <div class="text-center emoji-loader-init" style="display:none">
                <div class="spinner-border" role="status">
                  <span class="visually-hidden">Loading...</span>
                </div>
                <div>Preparing emojis...</div>
              </div>

              <div class="row p3 emoji-content-body" v-if="markdown.render_emojis">
                <div v-for="emoji of emojis" class="col-md-4">
                  <p>
                    <a @click="updateMarkdownText (emoji);" :data-emoji-target="emoji" class="insert-emoji" data-bs-dismiss="modal">
                      <img class="marked-emoji"
                        :src="'https://github.githubassets.com/images/icons/emoji/' + emoji.substring (1, emoji.length - 1) + '.png'"> {{ emoji }}
                    </a>
                  </p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div><!-- main-martor -->
  </div><!-- container-fluid -->

</template>












<style scoped>
.martor-toolbar .markdown-image-upload{position:relative;overflow:hidden}
.martor-toolbar .markdown-image-upload input[type=file]{position:absolute;top:0;right:0;min-width:100%;min-height:100%;font-size:25px;padding:0 0 0 35px;text-align:right;filter:alpha(opacity=0);opacity:0;outline:none;cursor:inherit;display:block}
.marked-emoji {max-width: 20px;}
.insert-emoji {
    cursor: pointer;
    text-decoration: none;
    color: #272062;
}
</style>

<style>
img[src^="https://github.githubassets.com/images/icons/emoji"] {
  width: 20px;
}
</style>









<script setup>

const EDITOR_INIT_HEIGHT = 150
let markdownit = null

const editor = ref (null)
const showForm = ref (false)
const emojis = [':yellow_heart:', ':blue_heart:', ':purple_heart:', ':heart:', ':green_heart:', ':broken_heart:', ':heartbeat:', ':heartpulse:', ':two_hearts:', ':revolving_hearts:', ':cupid:', ':sparkling_heart:', ':sparkles:', ':star:', ':star2:', ':dizzy:', ':boom:', ':collision:', ':anger:', ':exclamation:', ':question:', ':grey_exclamation:', ':grey_question:', ':zzz:', ':dash:', ':sweat_drops:', ':notes:', ':musical_note:', ':fire:', ':thumbsup:', ':-1:', ':thumbsdown:', ':ok_hand:', ':punch:', ':facepunch:', ':fist:', ':v:', ':wave:', ':hand:', ':raised_hand:', ':open_hands:', ':point_up:', ':point_down:', ':point_left:', ':point_right:', ':raised_hands:', ':pray:', ':point_up_2:', ':clap:', ':muscle:', ':nail_care:', ':sunny:', ':umbrella:', ':cloud:', ':snowflake:', ':zap:', ':cyclone:', ':foggy:', ':ocean:', ':bouquet:', ':cherry_blossom:', ':tulip:', ':four_leaf_clover:', ':rose:', ':sunflower:', ':hibiscus:', ':maple_leaf:', ':leaves:', ':fallen_leaf:', ':herb:', ':mushroom:', ':cactus:', ':palm_tree:', ':evergreen_tree:', ':deciduous_tree:', ':chestnut:', ':seedling:', ':blossom:', ':ear_of_rice:', ':shell:', ':globe_with_meridians:', ':new_moon:', ':waxing_crescent_moon:', ':first_quarter_moon:', ':waxing_gibbous_moon:', ':full_moon:', ':waning_gibbous_moon:', ':last_quarter_moon:', ':waning_crescent_moon:', ':last_quarter_moon_with_face:', ':first_quarter_moon_with_face:', ':crescent_moon:', ':earth_africa:', ':earth_americas:', ':earth_asia:', ':volcano:', ':milky_way:', ':partly_sunny:', ':bamboo:', ':gift_heart:', ':school_satchel:', ':mortar_board:', ':flags:', ':fireworks:', ':sparkler:', ':wind_chime:', ':rice_scene:', ':gift:', ':bell:', ':no_bell:', ':tanabata_tree:', ':tada:', ':confetti_ball:', ':balloon:', ':crystal_ball:', ':cd:', ':dvd:', ':floppy_disk:', ':camera:', ':video_camera:', ':movie_camera:', ':computer:', ':tv:', ':iphone:', ':phone:', ':telephone:', ':telephone_receiver:', ':pager:', ':fax:', ':minidisc:', ':vhs:', ':sound:', ':speaker:', ':mute:', ':loudspeaker:', ':mega:', ':hourglass:', ':hourglass_flowing_sand:', ':alarm_clock:', ':watch:', ':radio:', ':satellite:', ':loop:', ':mag:', ':mag_right:', ':unlock:', ':lock:', ':lock_with_ink_pen:', ':closed_lock_with_key:', ':key:', ':bulb:', ':flashlight:', ':high_brightness:', ':low_brightness:', ':electric_plug:', ':battery:', ':calling:', ':email:', ':mailbox:', ':postbox:', ':bath:', ':bathtub:', ':shower:', ':toilet:', ':wrench:', ':nut_and_bolt:', ':hammer:', ':seat:', ':moneybag:', ':yen:', ':dollar:', ':pound:', ':euro:', ':credit_card:', ':money_with_wings:', ':e-mail:', ':inbox_tray:', ':outbox_tray:', ':envelope:', ':incoming_envelope:', ':postal_horn:', ':mailbox_closed:', ':mailbox_with_mail:', ':mailbox_with_no_mail:', ':package:', ':door:', ':smoking:', ':bomb:', ':gun:', ':hocho:', ':pill:', ':syringe:', ':page_facing_up:', ':page_with_curl:', ':bookmark_tabs:', ':bar_chart:', ':chart_with_upwards_trend:', ':chart_with_downwards_trend:', ':scroll:', ':clipboard:', ':calendar:', ':date:', ':card_index:', ':file_folder:', ':open_file_folder:', ':scissors:', ':pushpin:', ':paperclip:', ':black_nib:', ':pencil2:', ':straight_ruler:', ':triangular_ruler:', ':closed_book:', ':green_book:', ':blue_book:', ':orange_book:', ':notebook:', ':notebook_with_decorative_cover:', ':ledger:', ':books:', ':bookmark:', ':name_badge:', ':microscope:', ':telescope:', ':newspaper:', ':football:', ':basketball:', ':soccer:', ':baseball:', ':tennis:', ':8ball:', ':rugby_football:', ':bowling:', ':golf:', ':gem:', ':ring:', ':trophy:', ':musical_score:', ':musical_keyboard:', ':violin:', ':video_game:', ':flower_playing_cards:', ':game_die:', ':dart:', ':clapper:', ':memo:', ':pencil:', ':book:', ':art:', ':microphone:', ':headphones:', ':trumpet:', ':saxophone:', ':guitar:', ':shoe:', ':sandal:', ':high_heel:', ':lipstick:', ':boot:', ':shirt:', ':tshirt:', ':necktie:', ':womans_clothes:', ':dress:', ':running_shirt_with_sash:', ':jeans:', ':kimono:', ':bikini:', ':ribbon:', ':tophat:', ':crown:', ':womans_hat:', ':mans_shoe:', ':closed_umbrella:', ':briefcase:', ':handbag:', ':pouch:', ':purse:', ':eyeglasses:', ':fishing_pole_and_fish:', ':coffee:', ':tea:', ':sake:', ':baby_bottle:', ':beer:', ':beers:', ':cocktail:', ':tropical_drink:', ':wine_glass:', ':fork_and_knife:', ':pizza:', ':hamburger:', ':fries:', ':poultry_leg:', ':meat_on_bone:', ':spaghetti:', ':curry:', ':fried_shrimp:', ':bento:', ':sushi:', ':fish_cake:', ':rice_ball:', ':rice_cracker:', ':rice:', ':ramen:', ':stew:', ':oden:', ':dango:', ':egg:', ':bread:', ':doughnut:', ':custard:', ':icecream:', ':ice_cream:', ':shaved_ice:', ':birthday:', ':cake:', ':cookie:', ':chocolate_bar:', ':candy:', ':lollipop:', ':honey_pot:', ':apple:', ':green_apple:', ':tangerine:', ':lemon:', ':cherries:', ':grapes:', ':watermelon:', ':strawberry:', ':peach:', ':melon:', ':banana:', ':pear:', ':pineapple:', ':sweet_potato:', ':eggplant:', ':tomato:', ':corn:', ':house:', ':house_with_garden:', ':school:', ':office:', ':post_office:', ':hospital:', ':bank:', ':convenience_store:', ':love_hotel:', ':hotel:', ':wedding:', ':church:', ':department_store:', ':european_post_office:', ':city_sunrise:', ':city_sunset:', ':japanese_castle:', ':european_castle:', ':tent:', ':factory:', ':tokyo_tower:', ':japan:', ':mount_fuji:', ':sunrise_over_mountains:', ':sunrise:', ':stars:', ':statue_of_liberty:', ':bridge_at_night:', ':carousel_horse:', ':rainbow:', ':ferris_wheel:', ':fountain:', ':roller_coaster:', ':ship:', ':speedboat:', ':boat:', ':sailboat:', ':rowboat:', ':anchor:', ':rocket:', ':airplane:', ':helicopter:', ':steam_locomotive:', ':tram:', ':mountain_railway:', ':bike:', ':aerial_tramway:', ':suspension_railway:', ':mountain_cableway:', ':tractor:', ':blue_car:', ':oncoming_automobile:', ':car:', ':red_car:', ':taxi:', ':oncoming_taxi:', ':articulated_lorry:', ':bus:', ':oncoming_bus:', ':rotating_light:', ':police_car:', ':oncoming_police_car:', ':fire_engine:', ':ambulance:', ':minibus:', ':truck:', ':train:', ':station:', ':train2:', ':bullettrain_front:', ':bullettrain_side:', ':light_rail:', ':monorail:', ':railway_car:', ':trolleybus:', ':ticket:', ':fuelpump:', ':vertical_traffic_light:', ':traffic_light:', ':warning:', ':construction:', ':beginner:', ':atm:', ':slot_machine:', ':busstop:', ':barber:', ':hotsprings:', ':checkered_flag:', ':crossed_flags:', ':izakaya_lantern:', ':moyai:', ':circus_tent:', ':performing_arts:', ':round_pushpin:', ':triangular_flag_on_post:', ':jp:', ':kr:', ':cn:', ':us:', ':fr:', ':es:', ':it:', ':ru:', ':gb:', ':uk:', ':de:', ':one:', ':two:', ':three:', ':four:', ':five:', ':six:', ':seven:', ':eight:', ':nine:', ':keycap_ten:', ':1234:', ':zero:', ':hash:', ':symbols:', ':arrow_backward:', ':arrow_down:', ':arrow_forward:', ':arrow_left:', ':capital_abcd:', ':abcd:', ':abc:', ':arrow_lower_left:', ':arrow_lower_right:', ':arrow_right:', ':arrow_up:', ':arrow_upper_left:', ':arrow_upper_right:', ':arrow_double_down:', ':arrow_double_up:', ':arrow_down_small:', ':arrow_heading_down:', ':arrow_heading_up:', ':leftwards_arrow_with_hook:', ':arrow_right_hook:', ':left_right_arrow:', ':arrow_up_down:', ':arrow_up_small:', ':arrows_clockwise:', ':arrows_counterclockwise:', ':rewind:', ':fast_forward:', ':information_source:', ':ok:', ':twisted_rightwards_arrows:', ':repeat:', ':repeat_one:', ':new:', ':top:', ':up:', ':cool:', ':free:', ':ng:', ':cinema:', ':koko:', ':signal_strength:', ':u5272:', ':u5408:', ':u55b6:', ':u6307:', ':u6708:', ':u6709:', ':u6e80:', ':u7121:', ':u7533:', ':u7a7a:', ':u7981:', ':sa:', ':restroom:', ':mens:', ':womens:', ':baby_symbol:', ':no_smoking:', ':parking:', ':wheelchair:', ':metro:', ':baggage_claim:', ':accept:', ':wc:', ':potable_water:', ':put_litter_in_its_place:', ':secret:', ':congratulations:', ':m:', ':passport_control:', ':left_luggage:', ':customs:', ':ideograph_advantage:', ':cl:', ':sos:', ':id:', ':no_entry_sign:', ':underage:', ':no_mobile_phones:', ':do_not_litter:', ':non-potable_water:', ':no_bicycles:', ':no_pedestrians:', ':children_crossing:', ':no_entry:', ':eight_spoked_asterisk:', ':sparkle:', ':eight_pointed_black_star:', ':heart_decoration:', ':vs:', ':vibration_mode:', ':mobile_phone_off:', ':chart:', ':currency_exchange:', ':aries:', ':taurus:', ':gemini:', ':cancer:', ':leo:', ':virgo:', ':libra:', ':scorpius:', ':sagittarius:', ':capricorn:', ':aquarius:', ':pisces:', ':ophiuchus:', ':six_pointed_star:', ':negative_squared_cross_mark:', ':a:', ':b:', ':ab:', ':o2:', ':diamond_shape_with_a_dot_inside:', ':recycle:', ':end:', ':back:', ':on:', ':soon:', ':clock1:', ':clock130:', ':clock10:', ':clock1030:', ':clock11:', ':clock1130:', ':clock12:', ':clock1230:', ':clock2:', ':clock230:', ':clock3:', ':clock330:', ':clock4:', ':clock430:', ':clock5:', ':clock530:', ':clock6:', ':clock630:', ':clock7:', ':clock730:', ':clock8:', ':clock830:', ':clock9:', ':clock930:', ':heavy_dollar_sign:', ':copyright:', ':registered:', ':tm:', ':x:', ':heavy_exclamation_mark:', ':bangbang:', ':interrobang:', ':o:', ':heavy_multiplication_x:', ':heavy_plus_sign:', ':heavy_minus_sign:', ':heavy_division_sign:', ':white_flower:', ':100:', ':heavy_check_mark:', ':ballot_box_with_check:', ':radio_button:', ':link:', ':curly_loop:', ':wavy_dash:', ':part_alternation_mark:', ':trident:', ':black_small_square:', ':white_small_square:', ':black_medium_small_square:', ':white_medium_small_square:', ':black_medium_square:', ':white_medium_square:', ':white_large_square:', ':white_check_mark:', ':black_square_button:', ':white_square_button:', ':black_circle:', ':white_circle:', ':red_circle:', ':large_blue_circle:', ':large_blue_diamond:', ':large_orange_diamond:', ':small_blue_diamond:', ':small_orange_diamond:', ':small_red_triangle:', ':small_red_triangle_down:']
const markdown = ref (
  {
    text: '',
    preview: '',
    editing: true,
    render_emojis: false,
    modified: false,
  }
)

async function updateMarkdownText (start, end, selstart = 0, selend = 0) {
  const textarea = editor.value
  const sel = window.getSelection ()
  const selCount = textarea.selectionEnd - textarea.selectionStart
  const selStart = textarea.selectionStart
  const selected = (textarea.value).substring(textarea.selectionStart, textarea.selectionEnd)
  const head = (textarea.value).substring (0, textarea.selectionStart)
  const tail =  (textarea.value).substring (textarea.selectionEnd, textarea.value.length)
  let newText = ''
  if (typeof (start) == 'function') {
    newText = start (selected)
    start = newText
  } else {
    newText = (start ? start:'') + selected + (end?end:'')
  }
  markdown.value.text = `${head}${newText}${tail}`
  let position = 0, s1, s2
  if (selCount) {
    position = selStart + newText.length
    s1 = position + selstart
    s2 = position + selend
  } else {
    position = selStart + start.length
    s1 = position
    s2 = position
  }
  textarea.focus ()
  await frontend.sleep (0)
  textarea.setSelectionRange (s1, s2)
}

function makeHeading (size) {
  let m = ''
  for (let i = 0; i < size; i++) {
    m += '#'
  }
  updateMarkdownText ('\n' + m + ' ')
}

function makeHLine () {
  updateMarkdownText ('\n-----------\n')
}

function makeBold () {
  updateMarkdownText ('**', '**')
}

function makeItalic () {
  updateMarkdownText ('*', '*')
}

function makeStrike () {
  updateMarkdownText ('~~', '~~')
}

function makeLink () {
  updateMarkdownText ('[', '](url)', -4, -1)
}

function makeImageLink () {
  updateMarkdownText ('![', '](url)', -4, -1)
}

function makeCode () {
  updateMarkdownText ('```\n', '\n```')
}

function makeTable () {
  updateMarkdownText ('| header | header |\n| ------ | ------ |\n|        |        |\n|        |        |')
}

function makeBlockquote () {
  updateMarkdownText ((text) => {
    const newLines = []
    for (let ln of text.split ('\n')) {
      newLines.push ('> ' + ln)
    }
    return newLines.join ('\n')
  })
}

function makeTodoList () {
  updateMarkdownText ((text) => {
    const newLines = []
    for (let ln of text.split ('\n')) {
      newLines.push ('- [ ] ' + ln)
    }
    return newLines.join ('\n')
  })
}

function makeUnorderedList () {
  updateMarkdownText ((text) => {
    const newLines = []
    for (let ln of text.split ('\n')) {
      newLines.push ('- ' + ln)
    }
    return newLines.join ('\n')
  })
}

function makeOrderedList () {
  updateMarkdownText ((text) => {
    const newLines = []
    let i = 0
    for (let ln of text.split ('\n')) {
      i ++
      newLines.push (i + '. ' + ln)
    }
    return newLines.join ('\n')
  })
}

async function continueEdit () {
  markdown.value.editing = true
  editor.value = await frontend.layout.wait_for_exist ('#markdown-text')
  adjustTextareaHeight ()
}

function render (text) {
  function customRender (p) {
    const emojis = [...p.matchAll (/:([_a-z0-9]+):/g)]
    for (let it of emojis) {
      p = p.replaceAll (it [0], `![${it [0]}](https://github.githubassets.com/images/icons/emoji/${it [1]}.png)`)
    }
    const html = markdownit.render (p)
    return html
  }
  if (!!text) {
    return customRender (text)
  }
  markdown.value.preview = customRender (markdown.value.text)
  markdown.value.editing = false
}

async function adjustTextareaHeight () {
  if (editor.value.scrollHeight >= EDITOR_INIT_HEIGHT) {
    const newHeight = Math.min (400, editor.value.scrollHeight)
    if (newHeight > editor.value.offsetHeight) {
      editor.value.style.height = newHeight + 'px'
    }
  }
}

function textModified () {
  markdown.value.modified = true
  adjustTextareaHeight ()
}

function getMarkdown () {
  showForm.value = false
  markdown.value.editing = false
  if (!!!markdown.value.text) {
    return ''
  }
  if (!markdown.value.modified) {
    return null
  }
  markdown.value.modified = false
  return markdown.value.text
}

async function setMarkdown (text) {
  markdown.value.text = text
  markdown.value.editing = true
  markdown.value.modified = false
  showForm.value = true
  editor.value = await frontend.layout.wait_for_exist ('#markdown-text')
  await frontend.sleep (1000)
  editor.value.focus ()
  adjustTextareaHeight ()
}

onBeforeMount (() => {
  markdownit = window.markdownit ()
})

onBeforeRouteLeave((to, from) => {
  // reset to read mode
  showForm.value = false
  markdown.value.editing = false
  markdown.value.modified = false
  markdown.value.text = ''
  markdown.value.preview = ''
})

defineExpose ({getMarkdown, setMarkdown, render})

</script>
